import { S as Store, E as Entry } from './interface-B5vFDb-6.cjs';
export { V as Value } from './interface-B5vFDb-6.cjs';
import { Redis } from 'ioredis';
import '@supabase-cache-helpers/postgrest-core';

type MemoryStoreConfig<TValue> = {
    persistentMap: Map<string, TValue>;
};
declare class MemoryStore implements Store {
    private readonly state;
    readonly name = "memory";
    constructor(config: MemoryStoreConfig<{
        expires: number;
        entry: Entry<any>;
    }>);
    get<Result>(key: string): Promise<Entry<Result> | undefined>;
    set<Result>(key: string, entry: Entry<Result>): Promise<void>;
    remove(keys: string | string[]): Promise<void>;
}

type RedisStoreConfig = {
    redis: Redis;
    prefix?: string;
};
declare class RedisStore implements Store {
    private readonly redis;
    readonly name = "redis";
    private readonly prefix;
    constructor(config: RedisStoreConfig);
    private buildCacheKey;
    get<Result>(key: string): Promise<Entry<Result> | undefined>;
    set<Result>(key: string, entry: Entry<Result>): Promise<void>;
    remove(keys: string | string[]): Promise<void>;
}

export { Entry, MemoryStore, type MemoryStoreConfig, RedisStore, type RedisStoreConfig, Store };
